import { Component, Type } from '@angular/core';
export declare const clearImporterCache: () => void;
export declare function importComponent({ path, alias, resolveFrom, pkgPathAliases, }: {
    path: string;
    /**
     * Named Export
     * @todo change to `namedExport`
     */
    alias?: string;
    resolveFrom?: string;
    pkgPathAliases?: Record<string, string>;
}): Promise<Type<Component>>;
export declare function getComponentNamesFromPkg({ path, pkgPathAliases, resolveFrom, }: {
    path: string;
    resolveFrom?: string;
    pkgPathAliases?: Record<string, string>;
}): Promise<string[]>;
//# sourceMappingURL=importer.d.mts.map