import { Component, NgModule, Type, Input, Output } from '@angular/core';
export declare const isDeclarable: (component: Type<unknown>) => boolean;
/**
 * Copied from Angular b/c they don't export this - https://github.com/angular/angular/blob/32ddac1fd6de42514c08830f5552e64c7945ea3e/packages/core/src/interface/type.ts#L21
 */
export declare const isType: (type: unknown) => type is Type<unknown>;
export declare const isComponent: (component: unknown) => component is Type<Component>;
export declare const isStandaloneComponent: (component: Type<unknown>) => component is Type<Component>;
export declare const isNgModule: (ngModule: Type<unknown>) => ngModule is Type<NgModule>;
export declare const isInput: (input: unknown) => input is Parameters<typeof Input>[0];
export declare const isOutput: (output: unknown) => output is Output;
//# sourceMappingURL=ng-type-guards.d.mts.map