// import { CommonModule } from '@angular/common';
// import {
//   Component,
//   Directive,
//   importProvidersFrom,
//   Injectable,
//   InjectionToken,
//   Input,
//   NgModule,
//   Output,
//   Pipe,
//   Provider,
//   ɵReflectionCapabilities as ReflectionCapabilities,
// } from '@angular/core';
// import { BrowserModule } from '@angular/platform-browser';
// import {
//   BrowserAnimationsModule,
//   NoopAnimationsModule,
//   provideAnimations,
//   provideNoopAnimations,
// } from '@angular/platform-browser/animations';
// import { NgModuleMetadata } from './types';
// import { isComponentAlreadyDeclared } from './ng-modules-analyzer';
export {};
// export const reflectionCapabilities = new ReflectionCapabilities();
// export const REMOVED_MODULES = new InjectionToken('REMOVED_MODULES');
// export const uniqueArray = (arr: any[]) => {
//   return arr
//     .flat(Number.MAX_VALUE)
//     .filter(Boolean)
//     .filter((value, index, self) => self.indexOf(value) === index);
// };
// export class PropertyExtractor implements NgModuleMetadata {
//   /* eslint-disable @typescript-eslint/lines-between-class-members */
//   declarations?: any[] = [];
//   imports?: any[];
//   providers?: Provider[];
//   applicationProviders?: Array<
//     Provider | ReturnType<typeof importProvidersFrom>
//   >;
//   /* eslint-enable @typescript-eslint/lines-between-class-members */
//   constructor(private metadata: NgModuleMetadata, private component?: any) {
//     this.init();
//   }
//   // With the new way of mounting standalone components to the DOM via bootstrapApplication API,
//   // we should now pass ModuleWithProviders to the providers array of the bootstrapApplication function.
//   static warnImportsModuleWithProviders(propertyExtractor: PropertyExtractor) {
//     const hasModuleWithProvidersImport = propertyExtractor.imports?.some(
//       (importedModule) => 'ngModule' in importedModule,
//     );
//     if (hasModuleWithProvidersImport) {
//       console.warn(
//         `
//           moduleMetadata property 'imports' contains one or more ModuleWithProviders`,
//       );
//     }
//   }
//   private init() {
//     const analyzed = this.analyzeMetadata(this.metadata);
//     this.imports = uniqueArray([CommonModule, analyzed.imports]);
//     this.providers = uniqueArray(analyzed.providers);
//     this.applicationProviders = uniqueArray(analyzed.applicationProviders);
//     this.declarations = uniqueArray(analyzed.declarations);
//     if (this.component) {
//       const { isDeclarable, isStandalone } =
//         PropertyExtractor.analyzeDecorators(this.component);
//       const isDeclared = isComponentAlreadyDeclared(
//         this.component,
//         analyzed.declarations,
//         this.imports,
//       );
//       if (isStandalone) {
//         this.imports.push(this.component);
//       } else if (isDeclarable && !isDeclared) {
//         this.declarations.push(this.component);
//       }
//     }
//   }
//   /**
//    * Analyze NgModule Metadata
//    *
//    * - Removes Restricted Imports
//    * - Extracts providers from ModuleWithProviders
//    * - Returns a new NgModuleMetadata object
//    *
//    *
//    */
//   private analyzeMetadata = (metadata: NgModuleMetadata) => {
//     const declarations = [...(metadata?.declarations || [])];
//     const providers = [...(metadata?.providers || [])];
//     const applicationProviders: Provider[] = [];
//     const imports = [...(metadata?.imports || [])].reduce((acc, imported) => {
//       // remove ngModule and use only its providers if it is restricted
//       // (e.g. BrowserModule, BrowserAnimationsModule, NoopAnimationsModule, ...etc)
//       const [isRestricted, restrictedProviders] =
//         PropertyExtractor.analyzeRestricted(imported);
//       if (isRestricted) {
//         applicationProviders.unshift(restrictedProviders || []);
//         return acc;
//       }
//       acc.push(imported);
//       return acc;
//     }, []);
//     return {
//       ...metadata,
//       imports,
//       providers,
//       applicationProviders,
//       declarations,
//     };
//   };
//   static analyzeRestricted = (
//     ngModule: NgModule,
//   ): [boolean] | [boolean, Provider] => {
//     if (ngModule === BrowserModule) {
//       console.warn(
//         `
//           You have imported the "BrowserModule", which is not necessary anymore.
//         `,
//       );
//       return [true];
//     }
//     if (ngModule === BrowserAnimationsModule) {
//       console.warn(
//         `
//           You have added the "BrowserAnimationsModule" to the list of "imports" in your moduleMetadata definition of your Story.
//         `,
//       );
//       return [true, provideAnimations()];
//     }
//     if (ngModule === NoopAnimationsModule) {
//       console.warn(
//         `
//           You have added the "NoopAnimationsModule" to the list of "imports" in your moduleMetadata
//         `,
//       );
//       return [true, provideNoopAnimations()];
//     }
//     return [false];
//   };
//   static analyzeDecorators = (component: any) => {
//     const decorators = reflectionCapabilities.annotations(component);
//     const isComponent = decorators.some((d) =>
//       this.isDecoratorInstanceOf(d, 'Component'),
//     );
//     const isDirective = decorators.some((d) =>
//       this.isDecoratorInstanceOf(d, 'Directive'),
//     );
//     const isPipe = decorators.some((d) =>
//       this.isDecoratorInstanceOf(d, 'Pipe'),
//     );
//     const isDeclarable = isComponent || isDirective || isPipe;
//     // Check if the hierarchically lowest Component or Directive decorator (the only relevant for importing dependencies) is standalone.
//     const isStandalone = !!(
//       (isComponent || isDirective) &&
//       [...decorators]
//         .reverse() // reflectionCapabilities returns decorators in a hierarchically top-down order
//         .find(
//           (d) =>
//             this.isDecoratorInstanceOf(d, 'Component') ||
//             this.isDecoratorInstanceOf(d, 'Directive'),
//         )?.standalone
//     );
//     return { isDeclarable, isStandalone };
//   };
//   static isDecoratorInstanceOf = (decorator: any, name: string) => {
//     let factory;
//     switch (name) {
//       case 'Component':
//         factory = Component;
//         break;
//       case 'Directive':
//         factory = Directive;
//         break;
//       case 'Pipe':
//         factory = Pipe;
//         break;
//       case 'Injectable':
//         factory = Injectable;
//         break;
//       case 'Input':
//         factory = Input;
//         break;
//       case 'Output':
//         factory = Output;
//         break;
//       default:
//         throw new Error(`Unknown decorator type: ${name}`);
//     }
//     return decorator instanceof factory || decorator.ngMetadataName === name;
//   };
// }
//# sourceMappingURL=property-extractor.mjs.map