import { Type } from '@angular/core';
export type ComponentInputsOutputs = {
    inputs: {
        propName: string;
        templateName: string;
        required?: boolean;
    }[];
    outputs: {
        propName: string;
        templateName: string;
    }[];
};
export declare function analyzeComponent(component: Type<unknown>): {
    inputs: {
        propName: string;
        templateName: string;
        required?: boolean;
    }[];
    outputs: {
        propName: string;
        templateName: string;
    }[];
    decoratorData: import("./ng-utils.mjs").DecoratorDataComponent;
    isStandalone: boolean;
    ngContentSelectors: string[];
    ngTemplateOutlets: string[];
    selector: string;
};
//# sourceMappingURL=ng-component-analyzer.d.mts.map