import '@angular/compiler';
import { Component, NgModule, ɵReflectionCapabilities as ReflectionCapabilities, Type } from '@angular/core';
export { reflectComponentType } from '@angular/core';
export declare const reflectionCapabilities: ReflectionCapabilities;
export type DecoratorDataComponent = {
    ngMetadataName: 'Component';
} & Parameters<typeof Component>[0];
type DecoratorDataNgModule = {
    ngMetadataName: 'NgModule';
} & Parameters<typeof NgModule>[0];
export declare function getComponentDecoratorData(component: Type<Component>): DecoratorDataComponent;
export declare function getNgModuleDecoratorData(ngModule: Type<NgModule>): DecoratorDataNgModule;
export declare function isComponentExportedFromNgModule({ component, ngModule, }: {
    ngModule: Type<NgModule>;
    component: Type<Component>;
}): boolean;
//# sourceMappingURL=ng-utils.d.mts.map